/* SPDX-License-Identifier: GPL-2.0-or-later */
/*
 * Copyright (C) Telechips Inc.
 */

#ifndef MAX96878_H
#define MAX96878_H

#include <linux/input/tcc_tsc_serdes.h>

static struct i2c_data hdmi_max96878_des_regs[] = {
	/* Touch IRQ : Des GPIO 15 RX/TX TX ID 15 */
	{HDMI_DES_ADDR, 0x022D, 0x81, TCC803X_EVB, 1, REV_ALL},
	{HDMI_DES_ADDR, 0x022E, 0x6F, TCC803X_EVB, 1, REV_ALL},
	/* Touch RST : Des GPIO 16 RX/TX RX ID 9 */
	{HDMI_DES_ADDR, 0x0230, 0x84, TCC803X_EVB, 1, REV_ALL},
	{HDMI_DES_ADDR, 0x0231, 0xB0, TCC803X_EVB, 1, REV_ALL},
	{HDMI_DES_ADDR, 0x0232, 0x29, TCC803X_EVB, 1, REV_ALL},
	/* Touch GPIO------------------------------- */

	/* IO RX_EN should be '1' */
	{HDMI_DES_ADDR, 0x022F, 0x2F, TCC803X_EVB, 1, REV_ALL},
	{HDMI_DES_ADDR, 0x022D, 0x83, TCC803X_EVB, 1, REV_ALL},
	/* OLDI DES PT1 enable */
	{HDMI_DES_ADDR, 0x0006, 0x01, TCC803X_EVB, 1, REV_ALL},
	/* OLDI DES ROUTE PT1 pins to GMSLPT1 */
	{HDMI_DES_ADDR, 0x0071, 0x02, TCC803X_EVB, 1, REV_ALL},
	/* GPIO14 I2C Driving */
	{HDMI_DES_ADDR, 0x022A, 0x18, TCC803X_EVB, 1, REV_ALL},

	{0, 0, 0, 0, 0, 0},
};

static struct i2c_data dp_max96878_des_regs[] = {
	/* Touch GPIO------------------------------- */
	/* Touch IRQ 1: Des GPIO #15 RX/TX TX ID 2 */
	{DP_DES1_ADDR, 0x022E, 0x62, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x022F, 0x2F, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x022D, 0x41, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x022D, 0x43, TCC805X_EVB, 1, REV_ALL},
	/* Touch RST 1 : Des GPIO #16 RX/TX TX ID 4 */
	{DP_DES1_ADDR, 0x0230, 0x84, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x0231, 0xB0, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x0232, 0x64, TCC805X_EVB, 1, REV_ALL},
	/* Touch IRQ 2 (TCC8059) : Des GPIO #15 Rx/TX TX ID 9 */
	{DP_DES2_ADDR, 0x022E, 0x69, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022F, 0x2F, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022D, 0x41, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022D, 0x43, TCC8059_EVB, 2, REV_ALL},
	/* Touch IRQ 2 (TCC8050) : Des GPIO #15 RX/TX TX ID 13 */
	{DP_DES2_ADDR, 0x022E, 0x6D, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022F, 0x2F, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022D, 0x41, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x022D, 0x43, TCC8050_EVB, 2, REV_ALL},
	/* Touch RST 2 (TCC8059) : Des GPIO #16 RX/TX TX ID 4 */
	{DP_DES2_ADDR, 0x0230, 0x84, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0231, 0xB0, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0232, 0x64, TCC8059_EVB, 2, REV_ALL},
	/* Touch RST 2 (TCC8050) : Des GPIO #16 RX/TX RX ID 12 */
	{DP_DES2_ADDR, 0x0230, 0x84, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0231, 0xB0, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0232, 0x6C, TCC8050_EVB, 2, REV_ALL},
	/* Touch IRQ 3 : Des GPIO #20 RX/TX RX ID 20 */
	{DP_DES3_ADDR, 0x022E, 0x74, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x022F, 0x2F, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x022D, 0x61, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x022D, 0x63, TCC8050_EVB, 3, REV_ALL},
	/* Touch RST 3: Des GPIO #19 RX/TX RX ID 12 */
	{DP_DES3_ADDR, 0x0230, 0x84, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x0231, 0xB0, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x0232, 0x73, TCC8050_EVB, 3, REV_ALL},
	/* Touch GPIO------------------------------- */

	{DP_DES1_ADDR, 0x022A, 0x18, TCC805X_EVB, 1, REV_ALL},
	{DP_DES2_ADDR, 0x022A, 0x18, TCC805X_EVB, 2, REV_ALL},
	{DP_DES3_ADDR, 0x022A, 0x18, TCC8050_EVB, 3, REV_ALL},

	/* OLDI DES1 PT1 enable */
	{DP_DES1_ADDR, 0x0006, 0x01, TCC805X_EVB, 1, REV_ALL},
	/* OLDI DES1 ROUTE PT1 pins to GMSLPT1 */
	{DP_DES1_ADDR, 0x0071, 0x02, TCC805X_EVB, 1, REV_ALL},

	/* OLDI DES2 PT1 enable */
	{DP_DES2_ADDR, 0x0006, 0x01, TCC8059_EVB, 2, REV_ALL},
	/* OLDI DES2 ROUTE PT1 pins to GMSLPT1 */
	{DP_DES2_ADDR, 0x0071, 0x02, TCC8059_EVB, 2, REV_ALL},
	/* OLDI DES2 PT2 enable */
	{DP_DES2_ADDR, 0x0006, 0x02, TCC8050_EVB, 2, REV_ALL},
	/* OLDI DES2 DIS ROUTE PT1 pins to GMSLPT1 */
	{DP_DES2_ADDR, 0x0071, 0x00, TCC8050_EVB, 2, REV_ALL},
	/* OLDI DES2 ROUTE PT1 pins to GMSLPT2 */
	{DP_DES2_ADDR, 0x0072, 0x02, TCC8050_EVB, 2, REV_ALL},

	/* OLDI DES3 PT2 enable */
	{DP_DES3_ADDR, 0x0006, 0x02, TCC8050_EVB, 3, REV_ALL},
	/* OLDI DES2 DIS ROUTE PT1 pins to GMSLPT1 */
	{DP_DES3_ADDR, 0x0071, 0x00, TCC8050_EVB, 3, REV_ALL},
	/* OLDI DES2 ROUTE PT1 pins to GMSLPT2 */
	{DP_DES3_ADDR, 0x0072, 0x02, TCC8050_EVB, 3, REV_ALL},

	/*  Touch IC Address Re-Assignment */
	{DP_DES1_ADDR, 0x0252, 0x96, TCC805X_EVB, 1, REV_ALL},
	{DP_DES1_ADDR, 0x0253, 0x94, TCC805X_EVB, 1, REV_ALL},

	{DP_DES2_ADDR, 0x0252, 0x9A, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0253, 0x94, TCC8059_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0256, 0x9A, TCC8050_EVB, 2, REV_ALL},
	{DP_DES2_ADDR, 0x0257, 0x94, TCC8050_EVB, 2, REV_ALL},

	{DP_DES3_ADDR, 0x0256, 0x9E, TCC8050_EVB, 3, REV_ALL},
	{DP_DES3_ADDR, 0x0257, 0x94, TCC8050_EVB, 3, REV_ALL},

	{0, 0, 0, 0, 0, 0},
};

#endif /* MAX96878_H */
